import com.nttdocomo.ui.*;
import java.io.*;
import java.util.*;

/*
	    ukQ[CuDoJa
	AvP[Vt[NX

	2007/07/25 ˁ@P

	createGameCanvas()AukGameCanvaspč쐬Q[LoX
	𐶐悤I[o[ChĂB
*/
class ukGameApplication extends IApplication implements ukGameMain {

	private ukGameApplication _app;
	private boolean _init = false;

	private ukGameStorage _storage;

	// Q[LoX
	private ukGameCanvas _cv;

	/**
	* AvP[VJn̏
	*/
	public void start() {

		if (_init) {
			return;
		}

		// sȂ߂
		if (!gameInit()) {
			return;
		}

		// Q[LoX
		_cv = createGameCanvas();

		// Q[LoXɃQ[AvP[Ṽ|C^ݒ
		_cv.ukSetGameMain(this);

		if (_cv == null) {
			return;
		}

		// Q[LoXs
		if (!_cv.ukInit()) {
			return;
		}

		Display.setCurrent(_cv);

		// Q[Jn
		_cv.ukStartGame();

		_init = true;

	}

	/**
	* Q[
	* Ǝ̏ŃI[o[Ch
	* @return trueAsfalse
	*/
	protected boolean gameInit() {
		return true;
	}

	/**
	* Q[̃LoXIuWFNg𐶐
	* ukGameCanvas̃TuNX̃CX^X𐶐悤I[o[Ch
	* @return LoXIuWFNg
	*/
	protected ukGameCanvas createGameCanvas() {
		return new ukGameCanvas();
	}

	// w薼̃\[XǂݍݗpXg[擾
	public InputStream ukGetResourceDataStream(String name) {

		if (name == null) {
			return null;
		}

		InputStream is = null;

		try {
			is = getClass().getResourceAsStream(name);
		} catch (Exception e) {
			is = null;
		}

		return is;

	}

	// w薼̃\[X̃oCif[^擾
	public byte[] ukGetResourceData(String name) {

		// \[XǂݍރXg[擾
		InputStream is = ukGetResourceDataStream(name);

		if (is == null) {
			return null;
		}

		ByteArrayOutputStream buf = new ByteArrayOutputStream();

		boolean flg = true;

		// Xg[f[^ǂݍ
		while (flg) {

			int dat = -1;

			try {
				dat = is.read();
			} catch (Exception e) {
				flg = false;
			}

			if (dat >= 0) {
				try {
					buf.write(dat);
				} catch (Exception ee) {}
			} else {
				flg = false;
			}

		}

		try {
			is.close();
		} catch(Exception ee) {
		}

		// \[X̃oCg쐬
		byte[] data = buf.toByteArray();

		return data;


	}

	/**
	* Q[f[^ۑ@\擾
	* @return Q[f[^ۑ@\
	*/
	public ukGameStorage ukGetGameStorage() {

		if (_storage == null) {

			_storage = new ukGameStorage();

			_storage.init();

		}

		return _storage;

	}

	public void pauseApp() {
		if (_cv != null) {
			_cv.onPause();
		}
	}

	public void destroyApp(boolean f) {

		_cv.ukDestroyCanvas();

	}

	// AvP[VNXi[t@Ciclass/jart@Cj擾
	public String getApplicationFileName() {
		return "ukGameApplication.class";
	}

	// AvP[VNXi[t@Ciclass/jart@CjURI擾
	public ukURI getApplicationFileURI() {

		ukURI uri = new ukURI(getSourceURL() + getApplicationFileName(), ukURI.UK_URI_TYPE_HTTP);

		return uri;

	}

	// AvP[VNXi[fBNgURI擾
	public ukURI getApplicationDirectoryURI() {

		ukURI uri = new ukURI(getSourceURL(), ukURI.UK_URI_TYPE_HTTP);

		return uri;

	}

	public void ukTerminateApplication() {
		terminate();
	}

}
