/*
	I_CAONX

	2007/10/13 ˁ@P
*/
public class ukSelectDialog extends ukWindow {

	private String[] _itemList;
	private int _pos, _select;

	private int _rgbBG, _rgbBGH;
	private int _rgbText, _rgbTextH;

	private int _lineSpace;
	private int _borderSpace;

	private boolean _visible;

	private int _waitCount, _wait;

	private ukFont _font;

	/**
	* ftHgRXgN^
	*/
	public ukSelectDialog() {

		_itemList = null;

		_pos = 0;
		_select = -1;

		_lineSpace = 2;
		_borderSpace = 4;

		_rgbBGH = 0x00c0c0c0;
		_rgbBG = 0x00000000;

		_rgbText = 0x00ffffff;
		_rgbTextH = 0x00000000;

		_wait = 3;

		_font = new ukFont();

	}

	// ڂǉ
	public boolean addItem(String item) {

		if (item == null) {
			return false;
		}

		if (_itemList == null) {

			_itemList = new String[1];

			_itemList[0] = new String(item);

		} else {

			int now = _itemList.length;

			String[] newList = new String[now + 1];

			for (int i = 0;i < now;i++) {
				newList[i] = new String(_itemList[i]);
			}

			newList[now] = new String(item);

			_itemList = newList;

		}

		int itemWidth = 0;
		int itemHeight = 0;

		int items = _itemList.length;

		// Sڕ`掞̍ƍő啝Zo
		for (int i = 0;i < items;i++) {

			if (_font.stringWidth(_itemList[i]) > itemWidth) {
				itemWidth = _font.stringWidth(_itemList[i]);
			}

			itemHeight += _font.getHeight() + _lineSpace;

		}

		// EChȆ傫
		int clientWidth = itemWidth + _borderSpace * 2;
		int clientHeight = itemHeight;

		setClientSize(clientWidth, clientHeight);

		return true;

	}

	// ݂̑I擾
	public int getPosition() {
		return _pos;
	}

	// ݂̑I擾
	public int getSelect() {
		return _select;
	}

	// Iݒ
	public void setSelect(int select) {
		_select = select;
	}

	// IɈړ
	public void up() {
		if (_pos > 0) {
			_pos--;
		}
	}

	// IɈړ
	public void down() {

		if (_itemList == null) {
			return;
		}

		if (_pos < _itemList.length - 1) {
			_pos++;
		}

	}

	public void setFont(ukFont f) {

		_font = new ukFont(f);

		if (_itemList == null) {
			return;
		}

		int itemWidth = 0;
		int itemHeight = 0;

		int items = _itemList.length;

		// Sڕ`掞̍ƍő啝Zo
		for (int i = 0;i < items;i++) {

			if (_font.stringWidth(_itemList[i]) > itemWidth) {
				itemWidth = _font.stringWidth(_itemList[i]);
			}

			itemHeight += _font.getHeight() + _lineSpace;

		}

		// EChȆ傫
		int clientWidth = itemWidth + _borderSpace * 2;
		int clientHeight = itemHeight;

		setClientSize(clientWidth, clientHeight);

	}

	/**
	* EChE`
	* @param g EChE[_Ƃ`pGraphicsIuWFNg
	*/
	protected synchronized void clientDraw(ukGraphics g) {

		int items = _itemList.length;

		ukFont oldFont = g.getFont();

		g.setFont(_font);

		int x = 0;
		int y = 0;

		// eڂ̕`
		for (int i = 0;i < items;i++) {

			// ڂ̍Zo
//			int lineHeight = g.getStringHeight(_itemList[i]) + _lineSpace;
			int lineHeight = _font.getHeight() + _lineSpace;

			if (i == _pos) {

				g.setRGB(_rgbBGH);
				g.fillRect(x, y, getClientWidth(), lineHeight);

				g.setRGB(_rgbTextH);
				g.drawString(_itemList[i], x + _borderSpace, y);


			} else {

				g.setRGB(_rgbBG);
				g.fillRect(x, y, getClientWidth(), lineHeight);

				g.setRGB(_rgbText);
				g.drawString(_itemList[i], x + _borderSpace, y);

			}

			y += lineHeight;

		}

		g.setFont(oldFont);

	}

	public boolean process(ukGameCanvas cv) {

		if (cv == null) {
			return false;
		}

		if (_select > 0) {
			return true;
		}

		if (cv.ukGetTrigger() == cv.UK_TRIGGER_A) {

			_select = _pos;

			return true;

		}

		_waitCount++;

		if (_waitCount < _wait) {
			return false;
		}

		_waitCount = 0;

		switch (cv.ukGetStick()) {

		case ukGameCanvas.UK_STICK_UP:

			up();

			break;

		case ukGameCanvas.UK_STICK_DOWN:

			down();

			break;

		}

		return false;

	}

}
