import com.nttdocomo.ui.*;
/*
	TEhf[^NX
*/
public class ukSoundData {

	private MediaSound _snd;
	protected boolean _loop;

	// wURITEhf[^쐬
	public ukSoundData(ukURI uri, boolean loop) {

		load(uri, loop);

	}

	// wbyte񂩂TEhf[^쐬
	public ukSoundData(byte[] data, boolean loop) {

		load(data, loop);

	}

	// wURITEhf[^ǂݍ
	public void load(ukURI uri, boolean loop) {

		if (uri == null) {

			reset();

			return;

		}

		load(uri.getData(), loop);

	}

	// wbyte񂩂TEhf[^ǂݍ
	public void load(byte[] data, boolean loop) {

		reset();

		try {

			_snd = MediaManager.getSound(data);

			_snd.use();

		} catch (Exception e) {
			_snd = null;
		}

		// [vݒۑ
		_loop = loop;

	}

	public MediaSound getSound() {
		return _snd;
	}

	public boolean getLoop() {
		return _loop;
	}

	public void setLoop(boolean loop) {
		_loop = loop;
	}

	public void reset() {

		release();

	}

	public void release() {

		if (_snd != null) {

			_snd.unuse();
			_snd.dispose();

			_snd = null;

		}

		_loop = false;

	}

}
