/**
	gtEChENX

	2007/10/13 ˁ@P
*/
public class ukWindow {

	// 
	private boolean _visible;

	// draw̕`挴_
	private int _x, _y;

	// EChETCY
	private int _width, _height;

	// ̑
	private int _borderWidth;

	// EChẼTCY
	private int _clientWidth, _clientHeight;

	// EChĚ_
	private int _clientX, _clientY;

	// ̐F
	private int _borderRGB;

	// EChE̐F
	private int _bgRGB;

	private final int DEFAULT_WIDTH = 120;
	private final int DEFAULT_HEIGHT = 120;

	private final int DEFAULT_BORDER_WIDTH = 2;

	/**
	* ftHgRXgN^
	*/
	public ukWindow() {

		_borderWidth = DEFAULT_BORDER_WIDTH;

		_borderRGB = 0x00ffffff;
		_bgRGB = 0x00000000;

		setSize(DEFAULT_WIDTH, DEFAULT_HEIGHT);

		setPosition(0, 0);

		_visible = true;

	}

	/**
	* wTCYŃbZ[WEChE𐶐
	* @param width 
	* @param height 
	*/
	public ukWindow(int width, int height) {

		_borderWidth = DEFAULT_BORDER_WIDTH;

		_borderRGB = 0x00ffffff;
		_bgRGB = 0x00000000;

		setSize(width, height);

		setPosition(0, 0);

		_visible = true;

	}

	/**
	* EChETCYݒ
	* @param width 
	* @param height 
	*/
	public void setSize(int width, int height) {

		_width = width;
		_height = height;

		_clientWidth = _width - (_borderWidth) * 2;
		_clientHeight = _height - (_borderWidth) * 2;

		onSizeChange();

	}

	/**
	* EChËTCYݒ
	* @param width 
	* @param height 
	*/
	public void setClientSize(int width, int height) {

		setSize(width + (_borderWidth) * 2, height + (_borderWidth) * 2);

	}

	/**
	* EChETCYύX̏
	*/
	public void onSizeChange() {
	}

	/**
	* EChẺ擾
	* @return EChẺ
	*/
	public int getWidth() {
		return _width;
	}

	/**
	* EChE̍擾
	* @return EChE̍
	*/
	public int getHeight() {
		return _height;
	}

	/**
	* EChẺ擾
	* @return EChẺ
	*/
	public int getClientWidth() {
		return _clientWidth;
	}

	/**
	* EChE̍擾
	* @return EChE̍
	*/
	public int getClientHeight() {
		return _clientHeight;
	}

	/**
	* \ʒuݒ
	* @param x XW
	* @param y YW
	*/
	public void setPosition(int x, int y) {

		// draw`挴_ݒ
		_x = x;
		_y = y;

		// EChE`挴_ݒ
		_clientX = _x + _borderWidth;
		_clientY = _y + _borderWidth;

	}

	/**
	* Ԑݒ
	* @param visible 
	*/
	public void setVisible(boolean visible) {
		_visible = visible;
	}

	/**
	* wukGraphicsɃEChE`
	* @param g `Ώ
	*/
	public synchronized void draw(ukGraphics g) {

		if (!_visible) {
			return;
		}

		// g`
		g.setRGB(_borderRGB);
		g.fillRect(_x, _y, _width, _height);

		// EChENA
		g.setRGB(_bgRGB);
		g.fillRect(_x + _borderWidth, _y + _borderWidth, _width - _borderWidth * 2, _height - _borderWidth * 2);

		// ݂̌_ݒۑ
		int offsetX = g.getOffsetX();
		int offsetY = g.getOffsetX();

		// EChE`pɌ_ݒ
		g.setOffset(_clientX, _clientY);

		// EChE̕`
		clientDraw(g);

		// _𕜋A
		g.setOffset(offsetX, offsetY);

	}

	/**
	* EChE`iEChE̕\eI[o[Chj
	* @param g EChE[_Ƃ`pGraphicsIuWFNg
	*/
	protected synchronized void clientDraw(ukGraphics g) {

	}

}
