/*
  ukQ[CuMIDP
  Q[LoXNX

  2007/07/20 ˁ@P
*/

/**
<pre>Q[LoXNX

	TuNXɂ

	init()ɃQ[̏
	game()ɃQ[̃[v
	draw()ɃQ[̕`揈
	destroy()ɃQ[Ȉ

	ĂB</pre>
*/
public class ukGameCanvas extends ukCanvas implements Runnable {

	private final int UK_DEFAULT_GAME_WIDTH = 240;
	private final int UK_DEFAULT_GAME_HEIGHT = 240;

	// Q[AvP[VstO
	protected volatile boolean _ukAlive;

	// XbhstO
	protected volatile boolean _ukThreadAlive;

	// Q[stO
	protected volatile boolean _ukExec;

	// Q[pXbh
	protected Thread _ukGame;

	// LoXobNobt@`pukGraphics
	protected ukGraphics _ukG;

	// LoXobNobt@
	protected ukImage _ukImg;

	// O񏈗
	private long _ukPrevTime = 0;

	// EGCgP
	private int _ukWait = 10;

	// 1t[̏
	private int _ukFrameTime = 30;

	// BGMĐpTEhvC[
	private ukSoundPlayer _ukBgm;

	// TEhgbNpTEhvC[
	private ukSoundPlayer[] _ukSndTrack;

	// TEhgbÑgbN
	private int _ukSndTrackNum = 2;

	private ukGameMain _app;

	private int _canvasWidth, _canvasHeight, _drawX, _drawY;
	private int _bgcolor;

	/**
	* ftHgRXgN^
	*/
	public ukGameCanvas() {
	}

	/**
	* VXe
	* @return trueAsfalse
	*/
	protected  boolean ukInit() {

		_canvasWidth = getWidth();
		_canvasHeight = getHeight();

		// LoXTCYݒ
		ukSetSize(UK_DEFAULT_GAME_WIDTH, UK_DEFAULT_GAME_HEIGHT);

		// AvP[VItOݒ
		_ukAlive = true;

		// Q[stOݒ
		_ukExec = true;

		// BGMtpvC[
		_ukBgm = new ukSoundPlayer();

		// TEhgbNpvC[z񐶐
		_ukSndTrack = new ukSoundPlayer[_ukSndTrackNum];

		// TEhgbNpvC[
		for (int i = 0;i < _ukSndTrack.length;i++) {
			_ukSndTrack[i] = new ukSoundPlayer();
		}

		// Q[s
		if (!init()) {
			return false;
		}

		return true;

	}

	/**
	* Q[
	* Q[JnOɓƎ̏KvȏꍇI[o[Ch
	* @return trueAsfalse
	*/
	protected boolean init() {
		return true;
	}

	/**
	* Q[JnɎIɌĂяoXbhN\bh
	* @return trueAsfalse
	*/
	public boolean ukStartGame() {

		// C[vpXbh
		_ukGame = new Thread(this);

		// XbhJn
		_ukGame.start();

		return true;

	}

	/**
	* LoXێukGameMainIuWFNgʒm
	* @param app ukGameMainAvP[VIuWFNg
	*/
	public void ukSetGameMain(ukGameMain app) {
		_app = app;
	}

	/**
	* C[v
	*/
	public void run() {

		// XbhtOZbg
		_ukThreadAlive = true;

		// Iw܂Ń[v
		while (_ukAlive && _ukExec) {

			// Cs
			_ukExec = game();

			if (_ukAlive && _ukExec) {

				// `揈
				ukUpdate();

				long now = System.currentTimeMillis();

				// O񏈗t[Ԃo߂܂ŃEGCg
				while (_ukAlive && (_ukPrevTime + _ukFrameTime > now)) {

					try {
						Thread.sleep(_ukWait);
					} catch(Exception e) {
					}

					now = System.currentTimeMillis();

				}

				// ̏IO񏈗ƂċL^
				_ukPrevTime = now;

			}

		}

		// XbhtOZbg
		_ukThreadAlive = false;

	}

	/**
	* Q[
	* Q[̃CŃI[o[Ch
	* @return Q[ptrueAIfalse
	*/
	protected boolean game() {
		return true;
	}

	/**
	* L[Ԏ擾
	* @return ݂̕L[
	*/
	public int ukGetStick() {
		return getStick();
	}

	/**
	* gK[L[Ԏ擾
	* @return ݂̃gK[L[
	*/
	public int ukGetTrigger() {
		return getTrigger();
	}

	/**
	* TEhgbNɃTEhǂݍ
	* @param track gbNԍ
	* @param snd TEhf[^
	* @return trueAsfalse
	*/
	protected boolean ukLoadSound(int track, ukSoundData snd) {

		if (track < 0 || track >= _ukSndTrackNum) {
			return false;
		}

		return _ukSndTrack[track].load(snd);

	}

	/**
	* TEhgbNɓǂݍ񂾃TEhĐ
	* @param track gbNԍ
	* @return trueAsfalse
	*/
	protected boolean ukPlaySound(int track) {

		if (track < 0 || track >= _ukSndTrackNum) {
			return false;
		}

		_ukSndTrack[track].play();

		return true;

	}

	/**
	* TEhgbNɃTEhǂݍōĐ
	* @param track gbNԍ
	* @param snd TEhf[^
	* @return trueAsfalse
	*/
	protected boolean ukPlaySound(int track, ukSoundData snd) {

		if (track < 0 || track >= _ukSndTrackNum) {
			return false;
		}

		// nullnꂽAݍĐ̃TEh~
		if (snd == null) {

			_ukSndTrack[track].stop();

			return true;

		}

		_ukSndTrack[track].play(snd);

		return true;

	}

	/**
	* wTEhf[^BGMɐݒi[vĐj
	* @param snd TEhf[^
	* @return trueAsfalse
	*/
	protected boolean ukSetBGM(ukSoundData snd) {

		// nullnꂽAݍĐBGM~
		if (snd == null) {

			_ukBgm.stop();

			return true;

		}

		snd.setLoop(true);

		_ukBgm.play(snd);

		return true;

	}

	/**
	* 1t[̎Ԑݒi~bPʁj
	* @param ms t[̍XVi~bj
	* @return trueAsfalse
	*/
	public boolean ukSetFrameTime(int ms) {

		if (ms < 1) {
			return false;
		}

		_ukFrameTime = ms;

		return true;

	}

	/**
	* LoXiobNobt@j`pukGraphics擾
	*/
	public ukGraphics getUkGraphics() {
		return _ukG;
	}

	/**
	* Q[`揈
	* `揈I[o[Ch
	* @param g `ΏۂƂēnukGraphics
	*/
	protected void draw(ukGraphics g) {
	}

	/**
	* LoXĕ`
	*/
	protected void ukUpdate() {

		// Q[`揈
		draw(_ukG);

		// `挋ʂLoXɕ\
		update();

	}

	/*
	* LoX̕`掞ɌĂяo`惁\bh
	* @param g `ΏۂƂēnukGraphics
	*/
	protected void onPaint(ukGraphics g) {

		g.setRGB(_bgcolor);
		g.fillRect(0, 0, _canvasWidth, _canvasHeight);

		// obNobt@`
		if (_ukImg != null) {
			g.drawImage(_ukImg, _drawX, _drawY);
		}

	}

	/**
	* LoX̔wiƌ݂̕`ewFŃNA
	*/
	public void ukClear(int rgb) {

		_ukImg.clear(rgb);
		_bgcolor = rgb;

		ukUpdate();

	}

	/**
	* `TCYݒ
	* @param width 
	* @param height 
	*/
	public void ukSetSize(int width, int height) {

		// obNobt@쐬
		_ukImg = new ukBitmap(width, height);

		// obNobt@`pukGraphicsۑ
		_ukG = _ukImg.getUkGraphics();

		_drawX = (_canvasWidth - width) / 2;
		_drawY = (_canvasHeight - height) / 2;

	}

	/**
	* R}hi\tgL[j͎̏I[o[Ch
	* @param ͂ꂽR}hԍ
	*/
	protected void onCommand(int command) {

	}

	/**
	* AvP[VI
	*/
	protected void ukTerminateApplication() {
		_app.ukTerminateApplication();
	}

	/**
	* LoXj
	*/
	public void ukDestroyCanvas() {

		// LoXtOZbg
		_ukAlive = false;

		int cnt = 0;

		while (_ukThreadAlive && ++cnt < 10) {

			// Q[XbhIҋ@
			try {
				Thread.sleep(10);
			} catch (Exception e) {
			}

		}

		// LoX̏Is
		destroy();

	}

	/**
	* |[Y̏
	*/
	public void ukOnPause() {

		resetKey();

		onPause();

	}

	/**
	* |[Y̏
	* ꎞfȂǃ|[YɕKvȏI[o[Ch
	*/
	protected void onPause() {
	}

	/**
	* W[i|[YAj̏
	*/
	public void ukOnResume() {

		resetKey();

		onResume();

	}

	/**
	* W[i|[YAj̏
	* W[ɕKvȏI[o[Ch
	*/
	protected void onResume() {
	}

	/**
	* \[Xf[^擾
	* @param \[Xt@C
	* @return \[X̃oCif[^
	*/
	protected byte[] ukGetResourceData(String name) {

		return _app.ukGetResourceData(name);

	}

	/**
	* ftHg̃Q[I
	* Q[ȈI[o[Ch
	*/
	protected void destroy() {
	}

}
