/*
	bZ[WEChENX

	2007/10/13 ˁ@P
*/
import java.util.*;

/**
* \郁bZ[WEChEB
*/
public class ukMessageWindow extends ukWindow {

	// processJEg
	private int _count;

	// y[W\
	private int _blink;

	// \
	private String _text;

	// \̍sz
	private String[] _lineList;

	// `TCY{́i֑̋pj
	private int _mesWidth, _mesHeight;

	// EChEƕ`̈̃Xy[X
	private int _padding;

	// s̍
	private int _lineHeight;

	// s
	private int _lineSpace;

	// ̕\Jns
	private int _linePos;

	// 1y[W̍s
	private int _viewLine;

	// `tHg
	private ukFont _font;

	// ̐F
	private int _textRGB;

	// y[W̐F
	private int _waitRGB;

	private final int DEFAULT_WIDTH = 120;
	private final int DEFAULT_HEIGHT = 120;

	private final int DEFAULT_PADDING = 2;

	private final int DEFAULT_LINE_SPACE = 2;

	private ukGameCanvas _cv;

	/**
	* ftHgRXgN^
	*/
	public ukMessageWindow() {

		super();

		_lineSpace = DEFAULT_LINE_SPACE;

		_padding = DEFAULT_PADDING;

		_lineList = null;
		_linePos = 0;

		_font = new ukFont();

		_lineHeight = _font.getHeight() + _lineSpace;

		_textRGB = 0x00ffffff;
		_waitRGB = 0x00ffffff;

		setSize(DEFAULT_WIDTH, DEFAULT_HEIGHT);

		setPosition(0, 0);

		_count = 0;
		_blink = 16;

	}

	/**
	* wTCYŃbZ[WEChE𐶐
	* @param width 
	* @param height 
	*/
	public ukMessageWindow(int width, int height) {

		super(width, height);

		_lineSpace = DEFAULT_LINE_SPACE;

		_padding = DEFAULT_PADDING;

		_lineList = null;
		_linePos = 0;

		_font = new ukFont();

		_lineHeight = _font.getHeight() + _lineSpace;

		_textRGB = 0x00ffffff;
		_waitRGB = 0x00ffffff;

		setSize(width, height);

		setPosition(0, 0);

		_count = 0;
		_blink = 16;

	}

	/**
	* ݒ
	* @param strݒ肷镶
	*/
	public void setText(String str) {

		if (str == null) {

			_text = null;

			_lineList = null;
			_linePos = 0;

			return;

		} else {
			_text = new String(str);
		}

		// eLXgsi[z񐶐
		Vector rows = new Vector();

		int xpos = 0;
		int spos = 0;

		// \Jnʒu
		_linePos = 0;

		while (spos < str.length()) {

			// s񐶐
			String line = new String();

			// sPʂɐ؂蕪
			do {

				// Ώە擾
				String ch = (new Character(str.charAt(spos))).toString();

				// Ώە̕\擾
				int width = _font.stringWidth(ch);

				// sw
				if (str.charAt(spos) == '\n') {

					xpos = 0;

					rows.addElement(new String(line));

					line = null;

				} else {

					// Ώەsɒǉ
					line += ch;

					// `ʒuXV
					xpos += width;

					// eLXgȂAsI
					if (spos == str.length() - 1) {

						rows.addElement(new String(line));

						line = null;

					} else {

						// ̕擾
						String nch = (new Character(str.charAt(spos + 1))).toString();

						// ̕̕`ʒu`敝͂ݏoȂAsI
						if (xpos + _font.stringWidth(nch) >= getClientWidth()) {

							xpos = 0;

							rows.addElement(new String(line));

							line = null;

						}

					}

				}

				// ΏۈʒuXV
				spos++;

			} while (line != null);

		}

		// `ΏەsPʂŊi[
		if (rows.size() > 0) {

			_lineList = new String[rows.size()];

			for (int i = 0;i < rows.size();i++) {
				_lineList[i] = new String((String)rows.elementAt(i));
			}

		}

		return;

	}

	/**
	* EChETCYύX̏
	*/
	public void onSizeChange() {

		// y[WsZo
		if (_lineHeight > 0) {
			_viewLine = getClientHeight() / _lineHeight;
		}

	}

	/**
	* `p̃tHgݒ
	* @param font tHg
	* @return trueAsfalse
	*/
	public boolean setFont(ukFont font) {

		if (font == null) {
			return false;
		}

		_font = font;

		setText(_text);

		return true;

	}

	/**
	* \ԁiׂĕ\Ay[WȂtruej
	* @param \
	*/
	public boolean isLastPage() {

		if (_lineList != null && _lineList.length > _linePos + _viewLine) {
			return false;
		}

		return true;

	}

	/**
	* y[W΃y[W
	* @param y[WtrueAbZ[W̕\Ȃfalse
	*/
	public boolean nextPage() {

		if (isLastPage()) {
			return false;
		}

		_linePos += _viewLine - 1;

		return !isLastPage();

	}

	/**
	* EChEiJ[\Ǘj
	*/
	public void process() {

		// JEgXV
		_count++;

		// y[W󖾖ŏ
		if (_count % _blink == 0) {
			_waitRGB = 0x00808080;
		}

		if (_count % _blink == 1) {
			_waitRGB = 0x00ffffff;
		}

		if (_count % _blink == (_blink / 2) + 1) {
			_waitRGB = 0x00808080;
		}

		if (_count % _blink == (_blink / 2) + 2) {
			_waitRGB = 0x00404040;
		}

		if (_count % _blink == (_blink / 2) + 3) {
			_waitRGB = 0x00000000;
		}

	}

	/**
	* wukGraphicsɃEChE`
	* @param g `Ώ
	*/
	public void clientDraw(ukGraphics g) {

		// \eLXgΕ`
		if (_lineList != null) {

			g.setFont(_font);

			// ̕`Fݒ
			g.setRGB(_textRGB);

			// \͈͂̊es\
			for (int i = 0;i < _viewLine;i++) {

				if (i + _linePos < _lineList.length) {

					// y[W΁A\
					if (i == _viewLine - 1 && _lineList.length > _linePos + _viewLine) {

						g.setRGB(_waitRGB);

						int centerX = getClientWidth() / 2;
						int bottomY = getClientHeight() - 2;

						// y[W`
						g.fillTriangle(centerX - 5, bottomY - 5, centerX + 5, bottomY - 5, centerX, bottomY);

					} else {
						g.drawString(_lineList[i + _linePos], _padding, i * _lineHeight + _padding);
					}

				}

			}

		}

	}

}

