import java.io.*;
import com.nttdocomo.ui.*;

/*
	TEhimldjvC[NX

	2007/06/02 ˁ@P

	ukSoundDataload()play()ĂB
*/
public class ukSoundPlayer implements MediaListener {

	// TEhĐIuWFNg
	private AudioPresenter _player;

	// [vĐtO
	private boolean _loop;

	// ĐtO
	private boolean _playing;

	private ukSoundData _data;

	public ukSoundPlayer() {

		_player = AudioPresenter.getAudioPresenter();

		_loop = false;
		_playing = false;

	}

	// w̉tpf[^vC[ɓǂݍ
	public boolean load(ukSoundData data) {

		// ݂̃f[^jAvC[̃\[XJ
		reset();

		if (data == null || data.getSound() == null) {
			return false;
		}

		try {
			_player.setSound(data.getSound());
		} catch (Exception e) {
			return false;
		}

		_player.setMediaListener(this);

		_loop = data.getLoop();

		_data = data;

		return true;

	}

	// wURI牉tpf[^vC[ɓǂݍ
	public boolean load(ukURI uri, boolean loop) {

		// ݂̃f[^jAvC[̃\[XJ
		reset();

		if (uri == null) {
			return false;
		}

		// wURITEhf[^쐬
		ukSoundData data = new ukSoundData(uri, loop);

		if (data == null || data.getSound() == null) {
			return false;
		}

		load(data);

		return true;

	}

	public boolean play(ukSoundData data) {

		if (!load(data)) {
			return false;
		}

		return play();

	}

	// ݓǂݍłTEhĐJn
	public boolean play() {

		if (_player == null) {
			return false;
		}

		// ĐJn
		try {
			_player.play();
		} catch (Exception e) {
			return false;
		}

		return true;

	}

	public void stop() {

		_playing = false;

	}

	// ێĂTEhf[^ׂĔjAvC[
	public void reset() {

		stop();

		_loop = false;

	}

	public void mediaAction(MediaPresenter source, int type, int param) {

		if (type == AudioPresenter.AUDIO_COMPLETE && _data != null && _data.getLoop()) {
			_player.play();
		}

	}

}
